<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm_00024_000_tab_produto_despesasService;
use SM\Traits\TResponse;

class Sm_00024_000_tab_produto_despesasController
{

    use TResponse;

    protected $produtoDespesasService;

    public function __construct(Sm_00024_000_tab_produto_despesasService $produtoDespesasService)
    {
        $this->produtoDespesasService = $produtoDespesasService;
    }

    public function getelementoproddesp()
    {
        try {
            $data = $this->produtoDespesasService->getelementoproddesp();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getservicoorca()
    {
        try {
            $data = $this->produtoDespesasService->getservicoorca();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getproduto_ultimo()
    {
        try {
            $data = $this->produtoDespesasService->getproduto_ultimo();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function adicionar_produto_despesas(Request $request)
    {
        try {
            $this->produtoDespesasService->adicionar_produto_despesas($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    } 
    
    public function excluir_produto_despesas(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->produtoDespesasService->excluir_produto_despesas($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

   }
