<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm_00024_000_tab_tipos_Operacoes_DespesasService;
use SM\Traits\TResponse;

class Sm_00024_000_tab_tipos_Operacoes_DespesasController
{

    use TResponse;

    protected $tiposOperacoesDespesasService;

    public function __construct(Sm_00024_000_tab_tipos_Operacoes_DespesasService $tiposOperacoesDespesasService)
    {
        $this->tiposOperacoesDespesasService = $tiposOperacoesDespesasService;
    }

    public function gettpoperdespdiv()
    {
        try {
            $data = $this->tiposOperacoesDespesasService->gettpoperdespdiv();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function gettipooperac()
    {
        try {
            $data = $this->tiposOperacoesDespesasService->gettipooperac();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function adicionar_tip_oper_desp(Request $request)
    {
        try {
            $this->tiposOperacoesDespesasService->adicionar_tip_oper_desp($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    } 

    public function excluir_tip_oper_desp(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->tiposOperacoesDespesasService->excluir_tip_oper_desp($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
   }
