<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm_00024_000_tab_despesa_de_Mao_de_ObraFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getmaoobracontctbl()
    {

        $sql = "SELECT
                    MAOO.NRMAOOBRACONTCTBL,
                    MAOO.CDSERVORCA,
                    SERV.NMSERVORCA,
                    MAOO.CDCONTCTBL,
                    CONT.NMCONTCTBL,
                    MAOO.NRORG,
                    MAOO.DTINCLUSAO,
                    MAOO.DTULTATU,
                    MAOO.NRORGINCLUSAO,
                    MAOO.CDOPERINCLUSAO,
                    MAOO.NRORGULTATU,
                    MAOO.CDOPERULTATU,
                    MAOO.IDATIVO
                FROM
                    FCT_MAOOBRACONTCTBL   MAOO
                    LEFT JOIN CONTCTBL              CONT ON MAOO.CDCONTCTBL = CONT.CDCONTCTBL
                    LEFT JOIN FCT_SERVICOORCA       SERV ON MAOO.CDSERVORCA = SERV.CDSERVORCA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getservicoorca()
    {

        $sql = "SELECT
                    CDSERVORCA,
                    CDFILIAL,
                    NMSERVORCA,
                    DSSERVORCA,
                    CDPRODFATSERV,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDATIVO,
                    IDTIPO,
                    IDELEMENTO,
                    IDTIPOELEMENTO,
                    IDELEMENTOPAI,
                    IDORDENAELEMENTO,
                    CDTPMEDIDAVARIAVEL,
                    IDFORMACAOPRECO,
                    DSSERVORCANF,
                    DSSERVORCABOL
                FROM FCT_SERVICOORCA
                    WHERE IDTIPO = 'E'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getcontctbl()
    {

        $sql = "SELECT
                    CDCONTCTBL,
                    CDRATEIO,
                    CDCONTREDU,
                    NMCONTCTBL,
                    CDNVCONTCTBL,
                    CDCONTANTE,
                    IDTIPOCONT,
                    IDTIPOPESS,
                    IDCONTCCUS,
                    IDTIPOCOME,
                    DTULTATUCCTB,
                    CDINDPLACON,
                    CDCTBLINTE,
                    IDNATUCONT,
                    CDCONTPLANREFE,
                    IDPADRREL,
                    CDCONTCTBLANALI,
                    CDCONTREFEAUX,
                    CDCONTREFEPRE,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDATIVO
                FROM CONTCTBL";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function adicionar_desp_mao_obra($params)
    {
        $sql = "INSERT INTO FCT_MAOOBRACONTCTBL (
                NRMAOOBRACONTCTBL, CDSERVORCA, CDCONTCTBL, 
                NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, 
                CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO 
                )
                VALUES (
                    :NRMAOOBRACONTCTBL, :CDSERVORCA, :CDCONTCTBL, :NRORG, SYSDATE, 
                    SYSDATE, :NRORG, :CDOPERINCLUSAO, :NRORG, :CDOPERINCLUSAO, 'S'
                    )";

        $this->connection->executeStatement($sql, $params);
    }

    public function excluir_desp_mao_obra($parametro)
    {
        $sql = "DELETE FROM FCT_MAOOBRACONTCTBL
        WHERE NRMAOOBRACONTCTBL IN (".$parametro.")";

        $this->connection->executeStatement($sql);
    }

    public function verificarItemRepetido($params)
    {
        $sql = "SELECT COUNT(*) AS EXISTE
                    FROM FCT_MAOOBRACONTCTBL
                WHERE CDSERVORCA = :CDSERVORCA
                    AND CDCONTCTBL    = :CDCONTCTBL";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

}
