<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm_00024_000_tab_produto_despesasFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getelementoproddesp()
    {

        $sql = "SELECT
                    ELEM.NRELEMENTOPRODDESP,
                    ELEM.CDSERVORCA,
                    SERV.NMSERVORCA,
                    ELEM.CDPRODUTO,
                    PROD.NMPRODUTO,
                    ELEM.NRORG,
                    ELEM.DTINCLUSAO,
                    ELEM.DTULTATU,
                    ELEM.NRORGINCLUSAO,
                    ELEM.CDOPERINCLUSAO,
                    ELEM.NRORGULTATU,
                    ELEM.CDOPERULTATU,
                    ELEM.IDATIVO
                FROM
                    FCT_ELEMENTOPRODDESP ELEM
                    LEFT JOIN FCT_SERVICOORCA SERV ON ELEM.CDSERVORCA = SERV.CDSERVORCA
                    LEFT JOIN (SELECT CDPRODUTO, CDARVPROD, NMPRODUTO, NRORG FROM PRODUTO
                        WHERE CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
                    ) PROD ON ELEM.CDPRODUTO = PROD.CDPRODUTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getservicoorca()
    {

        $sql = "SELECT
                    CDSERVORCA,
                    CDFILIAL,
                    NMSERVORCA,
                    DSSERVORCA,
                    CDPRODFATSERV,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDATIVO,
                    IDTIPO,
                    IDELEMENTO,
                    IDTIPOELEMENTO,
                    IDELEMENTOPAI,
                    IDORDENAELEMENTO,
                    CDTPMEDIDAVARIAVEL,
                    IDFORMACAOPRECO,
                    DSSERVORCANF,
                    DSSERVORCABOL
                FROM FCT_SERVICOORCA
                    WHERE IDTIPO = 'E'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getproduto_ultimo()
    {

        $sql = "SELECT
                    CDPRODUTO,
                    CDARVPROD,
                    NMPRODUTO,
                    NRORG
                FROM
                    PRODUTO
                WHERE
                    CDNVPRODUTO = (
                        SELECT
                            MAX(CDNVPRODUTO)
                        FROM
                            PRODUTO)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function adicionar_produto_despesas($params)
    {
        $sql = "INSERT INTO FCT_ELEMENTOPRODDESP (
                NRELEMENTOPRODDESP, CDSERVORCA, CDPRODUTO, 
                NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, 
                CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO 
                )
                VALUES (
                    :NRELEMENTOPRODDESP, :CDSERVORCA, :CDPRODUTO, 
                    :NRORG, SYSDATE, SYSDATE, :NRORG, 
                    :CDOPERINCLUSAO, :NRORG, :CDOPERINCLUSAO, 'S'
                    )";

        $this->connection->executeStatement($sql, $params);
    }

    public function excluir_produto_despesas($parametro)
    {
        $sql = "DELETE FROM FCT_ELEMENTOPRODDESP
        WHERE NRELEMENTOPRODDESP IN (".$parametro.")";

        $this->connection->executeStatement($sql);
    }

    public function verificarItemRepetido($params)
    {
        $sql = "SELECT COUNT(*) AS EXISTE
                    FROM FCT_ELEMENTOPRODDESP
                WHERE CDSERVORCA = :CDSERVORCA
                    AND CDPRODUTO    = :CDPRODUTO";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

}
