<?php
namespace SM\Service;

use SM\Factory\Sm_00024_000_tab_despesa_de_Mao_de_ObraFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Sm_00024_000_tab_despesa_de_Mao_de_ObraService
{

    protected $despesaMaoObraFactory;
    protected $environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, Sm_00024_000_tab_despesa_de_Mao_de_ObraFactory $despesaMaoObraFactory, Environment $environment, NewCode $newCode)
    {
        $this->connection          = $entityManager->getConnection();
        $this->despesaMaoObraFactory = $despesaMaoObraFactory;
        $this->environment         = $environment;
        $this->newCode             = $newCode;
    }

    public function getmaoobracontctbl()
    {
        return $this->despesaMaoObraFactory->getmaoobracontctbl();
    }

    public function getservicoorca()
    {
        return $this->despesaMaoObraFactory->getservicoorca();
    }

    public function getcontctbl()
    {
        return $this->despesaMaoObraFactory->getcontctbl();
    }

    public function adicionar_desp_mao_obra($params)
    {
        
        try {          
            $nrorg = $this->environment->getNrOrg();
            $cdoperador = $this->environment->getCdOperador();
            $novoCodigo = $this->newCode->getCodeByTableName("FCT_MAOOBRACONTCTBL", $nrorg, 1, 10, true);
            // var_dump($params); die;
            $dataParams = array(
                "NRMAOOBRACONTCTBL"      => $novoCodigo,
                "CDSERVORCA"             => $params[0]["CDSERVORCA"],
                "CDCONTCTBL"             => $params[0]["CDCONTCTBL"],
                "NRORG"                  => $nrorg,
                "NRORGINCLUSAO"          => $nrorg,
                "CDOPERINCLUSAO"         => $cdoperador,
                "NRORGULTATU"            => $nrorg,
                "CDOPERULTATU"           => $cdoperador                
            );
            
            $itemRepetido = $this->despesaMaoObraFactory->verificarItemRepetido($dataParams);
    
            if ($itemRepetido[0]["EXISTE"] > 0) {
                throw new \Exception("Operação Bloqueada! Os itens selecionados já existem.");
            }

            $this->despesaMaoObraFactory->adicionar_desp_mao_obra($dataParams);

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function excluir_desp_mao_obra($parametro)
    
    {
        $param = implode(',', $parametro["DMO"]);
        $this->despesaMaoObraFactory->excluir_desp_mao_obra($param);
    }

}

