<?php
namespace SM\Service;

use SM\Factory\Sm_00024_000_tab_produto_despesasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Sm_00024_000_tab_produto_despesasService
{

    protected $produtoDespesasFactory;
    protected $environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, Sm_00024_000_tab_produto_despesasFactory $produtoDespesasFactory, Environment $environment, NewCode $newCode)
    {
        $this->connection          = $entityManager->getConnection();
        $this->produtoDespesasFactory = $produtoDespesasFactory;
        $this->environment         = $environment;
        $this->newCode             = $newCode;
    }

    public function getelementoproddesp()
    {
        return $this->produtoDespesasFactory->getelementoproddesp();
    }

    public function getservicoorca()
    {
        return $this->produtoDespesasFactory->getservicoorca();
    }

    public function getproduto_ultimo()
    {
        return $this->produtoDespesasFactory->getproduto_ultimo();
    }

    public function adicionar_produto_despesas($params)
    {
        
        try {          
            $nrorg = $this->environment->getNrOrg();
            $cdoperador = $this->environment->getCdOperador();
            $novoCodigo = $this->newCode->getCodeByTableName("FCT_ELEMENTOPRODDESP", $nrorg, 1, 10, true);
            // var_dump($params); die;
            $dataParams = array(
                "NRELEMENTOPRODDESP"      => $novoCodigo,
                "CDSERVORCA"             => $params[0]["CDSERVORCA"],
                "CDPRODUTO"             => $params[0]["CDPRODUTO"],
                "NRORG"                  => $nrorg,
                "NRORGINCLUSAO"          => $nrorg,
                "CDOPERINCLUSAO"         => $cdoperador,
                "NRORGULTATU"            => $nrorg,
                "CDOPERULTATU"           => $cdoperador                
            );
            
            $itemRepetido = $this->produtoDespesasFactory->verificarItemRepetido($dataParams);
    
            if ($itemRepetido[0]["EXISTE"] > 0) {
                throw new \Exception("Operação Bloqueada! Os itens selecionados já existem.");
            }

            $this->produtoDespesasFactory->adicionar_produto_despesas($dataParams);

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function excluir_produto_despesas($parametro)
    
    {
        $param = implode(',', $parametro["PD"]);
        $this->produtoDespesasFactory->excluir_produto_despesas($param);
    }

}

